%
% $Id: vacation.pl,v 1.1 2009-07-17 07:45:49 esimon Exp $
%
% File generated by HeKatE Qt Editor ver. M6_5
%
% HeaRT case
%
%
%     Copyright (C) 2006-9 by the HeKatE Project
%
%     HeaRT has been develped by the HeKatE Project, 
%     see http://hekate.ia.agh.edu.pl
%
%     This file is part of HeaRT.
%
%     HeaRT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     HeaRT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with HeaRT.  If not, see <http://www.gnu.org/licenses/>.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- ensure_loaded('heart.pl').

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% TYPES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%

xtype [name: boolean,
       base: numeric,
       length: 1,
       scale: 0,
       desc: boolean,
       domain: [0,1]
      ].
xtype [name: integer,
       base: numeric,
       length: 9,
       scale: 0,
       desc: integer,
       domain: [-999999999 to 999999999]
      ].


xtype [name: age_type,
       base: numeric,
       length: 3,
       scale: 0,
       domain: [1 to 100]
      ].
xtype [name: service_type,
       base: numeric,
       length: 3,
       scale: 0,
       domain: [0 to 82]
      ].
xtype [name: vacation_type,
       base: numeric,
       length: 2,
       scale: 0,
       domain: [0 to 32]
      ].

%%%%%%%%%%%%%%%%%%%%%%%%% ATTRIBUTES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%

xattr [name: age,
       abbrev: age1,
       class: simple,
       type: age_type,
	   callback:[ask_GUI,[age]],
       comm: in
      ].
xattr [name: service,
       abbrev: serv1,
       class: simple,
       type: age_type,
	   callback:[ask_GUI,[service]],
       comm: in
      ].
xattr [name: vacation,
       abbrev: vaca1,
       class: simple,
       type: vacation_type,
	   callback:[tell_console,[vacation]],
       comm: out
      ].

%%%%%%%%%%%%%%%%%%%%%%%%% STATES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%

xstat 'Start': [agee,34].
xstat 'Start': [servicee,12].

%%%%%%%%%%%%%%%%%%%%%%%% TABLE SCHEMAS DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%

xschm 'Vacation': [age,service] ==> [vacation].

%%%%%%%%%%%%%%%%%%%%%%%%%%%% RULES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%

xrule 'Vacation'/1:
      [age lt 18,
       service eq 'any']
    ==>
      [vacation set 27].
xrule 'Vacation'/2:
      [age in [18 to 44],
       service lt 25]
    ==>
      [vacation set 22].
xrule 'Vacation'/3:
      [age in [18 to 59],
       service in [25 to 39]]
    ==>
      [vacation set 24].
xrule 'Vacation'/4:
      [age in [45 to 59],
       service lt 25]
    ==>
      [vacation set 24].
xrule 'Vacation'/5:
      [age in [45 to 59],
       service gte 40]
    ==>
      [vacation set 27].
xrule 'Vacation'/6:
      [age gte 60,
       service eq 'any']
    ==>
      [vacation set 27].

xcall ask_GUI : [AttName] >>> (jpl_new('JHeart.Therm',[],T),
	 alsv_domain(Att,[Min to Max],numeric),
	 concat_atom(['[',Att,',',Min,',',Max,']'],Parameter),
	 jpl_call(T,request,[T,Parameter],Answer),
	 atom_to_term(Answer,Answer2,_),
	 alsv_new_val(Att,Answer2)).
xcall tell_console : [AttName] >>> (write('Attribute '),write(AttName),write(' output value is '),
								 xstat(current:[AttName,V]),
								 write(V),nl).
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File generated by HeKatE Qt Editor ver. M6_5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%